<template functional>
  <div
    :ref="data.ref"
    data-cid="{ BhFilterOptionUi }"
    class="[ bh-filter-option-ui ][ flex flex-nowrap ]"
    :class="[data.staticClass, data.class]"
    :style="[data.staticStyle, data.style]"
    :data-state="props.isDisabled ? 'disabled' : 'active'"
    :data-selected="props.isSelected"
    v-bind="data.attrs"
    v-on="listeners"
  >
    <!-- Square -->
    <div
      class="flex-schrink-0 flex justify-center items-center h-10 w-10 text-gray-50"
      :style="{ 'background-color': props.color }"
    >
      <slot name="square" />
    </div>

    <!-- Label -->
    <div class="flex-1 p-2">
      <slot />
    </div>
  </div>
</template>

<script>
export default {
  name: 'BhFilterOptionUi',
  props: {
    color: {
      type: String,
      required: true,
    },
    isSelected: {
      type: Boolean,
      default: false,
    },
    isDisabled: {
      type: Boolean,
      default: false,
    },
  },
};
</script>

<style lang="postcss" scoped>
.bh-filter-option-ui[data-state='disabled'] > div:last-of-type {
  @apply text-gray-400;
}
.bh-filter-option-ui[data-state='active'] > div:last-of-type {
  @apply cursor-pointer transition duration-150 ease-in-out;
}
.bh-filter-option-ui[data-state='active']:hover > div:last-of-type {
  @apply bg-gray-200 text-gray-900;
}
.bh-filter-option-ui[data-selected] > div:last-of-type {
  @apply bg-gray-300 text-gray-900;
}
</style>
